import * as UpdateQueue from './UpdateQueue';
export class tswCtx {
    id;
    propVals;
    childCtxs;
    ctxParent;
    static CtxLastId = 0;
    constructor() {
        this.id = ++tswCtx.CtxLastId;
    }
    getRootCtx() {
        return undefined;
    }
    getParent() {
        return this.ctxParent;
    }
    addCtxToParent(ctxParent) {
        if (ctxParent == null) {
        }
        else if (this.shouldBeAddedToParent()) {
            ctxParent.addChild(this);
        }
        else {
        }
    }
    addPropVal(propVal) {
        if (!this.propVals)
            this.propVals = new Set();
        this.propVals.add(propVal);
    }
    shouldBeAddedToParent() {
        return this.hasChildren() || this.hasPropVals();
    }
    hasPropVals() {
        return isNotEmptySet(this.propVals);
    }
    hasChildren() {
        return isNotEmptySet(this.childCtxs);
    }
    forEachChild(action) {
        if (this.childCtxs)
            this.childCtxs.forEach(action);
    }
    removeChildren() {
        this.cleanup();
        this.forEachChild(ctx => {
            ctx.ctxParent = null;
            ctx.removeChildren();
        });
        if (this.childCtxs)
            this.childCtxs.clear();
    }
    cleanup() {
        UpdateQueue.removeFromUpdateQueue(this);
        this.detachPropVals();
    }
    detachPropVals() {
        const propVals = this.propVals;
        this.propVals = null;
        if (propVals) {
            propVals.forEach(pv => {
                pv.ctxRemove(this);
            });
        }
    }
    addRef(ref) {
        throw new Error("Not implemented");
    }
    addChild(ctx) {
        if (this.childCtxs == null)
            this.childCtxs = new Set();
        this.childCtxs.add(ctx);
        ctx.ctxParent = this;
    }
    replaceNode(nodeKind, oldNode, newNode) {
    }
    notifySelfAndChildren(action) {
        action(this, true);
        this.forEachChild(ctx => {
            ctx.notifySelfAndChildren(action);
        });
        action(this, false);
    }
    domChange(beforeChildren, attach) {
    }
    dbg_getChildren() {
        return this.childCtxs;
    }
    dbg_getPropVals() {
        return this.propVals;
    }
}
export function isNotEmptySet(s) {
    return s && s.size > 0;
}
