import { tswCtx, NodeKind } from './Ctx';
import { childValType, childValTypePropDefReadable, tswRenderer, childValTypeFn, ElmEventMapItem, ICtxRoot, DomChangeEventListener } from './types';
import { tswRef } from './ref';
export declare abstract class tswCtxNodeBase extends tswCtx {
    protected firstChild: Node | null;
    protected lastChild: Node | null;
    private elementsWithRootEvents?;
    private refs?;
    private domChangeListeners?;
    get dbg_firstChild(): Node | null;
    get dbg_lastChild(): Node | null;
    get dbg_elementsWithRootEvents(): Set<Element> | undefined;
    get dbg_domChangeListeners(): Set<DomChangeEventListener> | undefined;
    abstract getRootCtx(): ICtxRoot;
    protected removeOldContent(parentNode: Node): void;
    protected addNewContent(parentNode: Node, nodeBefore: Node | null, content: childValType): void;
    protected shouldBeAddedToParent(): boolean | import("./types").nothing;
    cleanup(): void;
    addRef(ref: tswRef): void;
    private resetRefs;
    detachEventHandlers(): void;
    domChange(beforeChildren: boolean, attach: boolean): void;
    replaceNode(nodeKind: NodeKind, oldNode: Node | null, newNode: Node | null): void;
    protected removeNodes(parentNode: Node): void;
    protected addNodes(parentNode: DocumentFragment | Element, content: childValType): void;
    addEventHandlers(el: Element, elmEventMapItem: ElmEventMapItem): void;
    private insertContent;
    private setupElement;
    private addEventListeners;
    private addValueContext;
    private addValueEventHandlers;
    private createAttrs;
    private createAttrMap;
}
export declare class tswCtxNodes extends tswCtxNodeBase {
    private content;
    private ctxRoot?;
    constructor(content: childValTypeFn | childValTypePropDefReadable | tswRenderer);
    getRootCtx(): ICtxRoot;
    setup(ctxParent: tswCtx, parentNode: DocumentFragment | Element): void;
    update(): void;
    private createContent;
    private getContent;
    get dbg_content(): tswRenderer | childValTypeFn | childValTypePropDefReadable;
}
