import { tswCtxNodeBase } from "./CtxNodes";
import { tswRootEventHandler } from "./RootEventHandler";
export class tswCtxRoot extends tswCtxNodeBase {
    htmlElement;
    onBeforeAttach;
    rootEventHandler;
    constructor(htmlElement) {
        super();
        this.htmlElement = htmlElement;
    }
    setContent(content) {
        const parentNode = this.htmlElement;
        const nodeBefore = this.lastChild == null ? null : this.lastChild.nextSibling;
        this.removeOldContent(parentNode);
        this.addNewContent(parentNode, nodeBefore, content);
    }
    update() {
        throw new Error("not implemented");
    }
    getRootCtx() {
        return this;
    }
    invokeBeforeAttach() {
        if (this.onBeforeAttach)
            this.onBeforeAttach();
    }
    attachElmEventHandler(el, elmEventMapItem) {
        if (this.rootEventHandler == null)
            this.rootEventHandler = new tswRootEventHandler(this.htmlElement);
        this.rootEventHandler.attachElmEventHandler(el, elmEventMapItem);
    }
    detachElmEventHandlers(el) {
        if (this.rootEventHandler != null) {
            this.rootEventHandler.detachElmEventHandlers(el);
            if (!this.rootEventHandler.hasHandlers())
                this.rootEventHandler = undefined;
        }
    }
    get dbg_rootEventHandler() { return this.rootEventHandler; }
    get dbg_getElement() { return this.htmlElement; }
}
