import { privates, tswElement } from './elm';
import { boolValType, singleStringValType, PropDef, ElementValueInfo, ValueChangeHandler, nothing } from "./types";
import { tswRef } from './ref';
export declare class tswRawHtml {
    value: string;
    constructor(value: string);
}
export declare class tswElementButton extends tswElement {
    constructor();
    type(val: singleStringValType): this;
}
export declare class tswElementA extends tswElement {
    constructor();
    href(val: singleStringValType): this;
}
export declare class tswElementImg extends tswElement {
    constructor();
    src(val: singleStringValType): this;
}
export declare type elmValue = string | number | boolean | null;
export declare abstract class tswElementWithValueBase extends tswElement {
    abstract [privates.ElementWithValueBase.getValueInfos](): ElementValueInfo | ElementValueInfo[] | nothing;
}
export declare abstract class tswElementWithValue<T extends elmValue> extends tswElementWithValueBase {
    private propName;
    protected propDef?: PropDef<T>;
    protected onChange?: ValueChangeHandler;
    constructor(tagName: string, propName: string);
    value(propDef: PropDef<T>, onChange?: ValueChangeHandler<T>): this;
    [privates.ElementWithValueBase.getValueInfos](): ElementValueInfo | ElementValueInfo[] | nothing;
}
export declare class tswElementInput<T extends elmValue> extends tswElementWithValue<T> {
    constructor(type: string, propName: string);
}
export declare class tswElementInputText extends tswElementInput<string> {
    constructor();
    placeholder(v: singleStringValType): this;
    autocomplete(v: singleStringValType): this;
}
export declare class tswElementInputCheckboxBase extends tswElementInput<boolean> {
    constructor(type: string);
}
export declare class tswElementInputCheckbox extends tswElementInputCheckboxBase {
    constructor();
}
export declare class tswElementInputRadio extends tswElementInputCheckboxBase {
    constructor();
}
export declare class tswElementTextArea extends tswElementWithValue<string> {
    constructor();
    placeholder(v: singleStringValType): this;
}
export declare class tswElementSelect extends tswElementWithValueBase {
    private propInfos?;
    constructor();
    value(propDef: PropDef<string>, onChange?: ValueChangeHandler<string>): this;
    selectedIndex(propDef: PropDef<number>, onChange?: ValueChangeHandler<number>): this;
    [privates.ElementWithValueBase.getValueInfos](): ElementValueInfo | ElementValueInfo[] | nothing;
}
export declare class tswElementOption extends tswElement {
    constructor();
    value(val: singleStringValType): this;
    selected(val: boolValType): this;
}
export declare class tswElementLabel extends tswElement {
    constructor();
    forId(id: singleStringValType): this;
    forRef(ref: tswRef | nothing): this;
}
export declare class tswElementTD extends tswElement {
    colSpan(val: number): this;
    rowSpan(val: number): this;
}
export declare function cast<T>(v: T): T;
