import { tswElement } from "./elm";
import { Fn, nothing, PropDefReadable, singleStringValType } from "./types";
declare type numberNullable = number | nothing | false;
declare type numberValType = numberNullable | Fn<numberNullable> | PropDefReadable<numberNullable>;
export declare function el(tagName: string): tswElementSVG;
export declare function svg(): tswElementSVG_SVG;
export declare function circle(): tswElementSVG_Circle;
export declare function rect(): tswElementSVG_Rect;
export declare function path(): tswElementSVG_Path;
export declare class tswElementSVG extends tswElement {
    constructor(tagName: string);
    stroke(v: singleStringValType): this;
    strokeWidth(v: numberValType): this;
    fill(v: singleStringValType): this;
}
export declare class tswElementSVG_SVG extends tswElementSVG {
    constructor();
    width(v: numberValType): this;
    height(v: numberValType): this;
    viewBox(v: singleStringValType): this;
}
export declare class tswElementSVG_Circle extends tswElementSVG {
    constructor();
    cx(v: numberValType): this;
    cy(v: numberValType): this;
    r(v: numberValType): this;
}
export declare class tswElementSVG_Rect extends tswElementSVG {
    constructor();
    x(v: numberValType): this;
    y(v: numberValType): this;
    width(v: numberValType): this;
    height(v: numberValType): this;
}
export declare class tswElementSVG_Path extends tswElementSVG {
    constructor();
    d(v: singleStringValType): this;
}
export {};
