import { tswElement } from "./elm";
export function el(tagName) { return new tswElementSVG(tagName); }
export function svg() { return new tswElementSVG_SVG(); }
export function circle() { return new tswElementSVG_Circle(); }
export function rect() { return new tswElementSVG_Rect(); }
export function path() { return new tswElementSVG_Path(); }
const svgNS = "http://www.w3.org/2000/svg";
export class tswElementSVG extends tswElement {
    constructor(tagName) {
        super(tagName, svgNS, true);
    }
    stroke(v) { this.attr('stroke', v); return this; }
    strokeWidth(v) { this.attr('stroke-width', v); return this; }
    fill(v) { this.attr('fill', v); return this; }
}
export class tswElementSVG_SVG extends tswElementSVG {
    constructor() {
        super('svg');
    }
    width(v) { this.attr('width', v); return this; }
    height(v) { this.attr('height', v); return this; }
    viewBox(v) { this.attr('viewBox', v); return this; }
}
export class tswElementSVG_Circle extends tswElementSVG {
    constructor() {
        super('circle');
    }
    cx(v) { this.attr('cx', v); return this; }
    cy(v) { this.attr('cy', v); return this; }
    r(v) { this.attr('r', v); return this; }
}
export class tswElementSVG_Rect extends tswElementSVG {
    constructor() {
        super('rect');
    }
    x(v) { this.attr('x', v); return this; }
    y(v) { this.attr('y', v); return this; }
    width(v) { this.attr('width', v); return this; }
    height(v) { this.attr('height', v); return this; }
}
export class tswElementSVG_Path extends tswElementSVG {
    constructor() {
        super('path');
    }
    d(v) { this.attr('d', v); return this; }
}
